<?php
/**
 * Created by JetBrains PhpStorm.
 * User: erikasouza
 * Date: 29/11/12
 * Time: 17:12
 * To change this template use File | Settings | File Templates.
 */
namespace Estoque\Logic\Exception;

class ExceptionLancamentoEstoque extends \Geral\Logic\Exception
{


    private $messageName;
    private $messageNameAcumulado;
    private $paramsAcumulado;


    public function __construct($messagemName, $param = null){
        parent::__construct($messagemName);
        $this->messageName = $messagemName;
        // $this->params = $param;
        $this->addParam($param);
    }

    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }

    /**
     * Retorna o parametro da mensagem para esta excecao.
     *
     * @return string
     */
    public function getParam()
    {
        return $this->getParams();
    }


    public function acumulaMensagem($NmMensagem, $params){
        $this->messageNameAcumulado = $NmMensagem;
        $this->paramsAcumulado = $params;
    }


    public static function erroDtIgualDtProcessamento(){
        throw new self('est42000_dtIgualProc');
    }


    public static function erroDtMaiorOuIgual(){
        throw new self('est42000_dtMaiorIgual');
    }


    public static function erroDtForaPeriodo(){
        throw new self('est42000_dtForaPeriodo');
    }


    public static function erroDtMenorOuIgual(){
        throw new self('est42000_dtMenorIgual');
    }


    public static function erroProdutoCadastrado(){
        throw new self('est42000_prodJaCadastrado');
    }


    public static function erroMesFechado(){
        throw new self('est42000_mesFechado');
    }


    public static function erroVrLiqMenorZero(){
        throw new self('est42000_vrLiqMenorZero');
    }


    public static function erroVrBrutoMenorZero(){
        throw new self('est42000_vrBrutoMenorZero');
    }


    public static function erroVrUniIgualZero(){
        throw new self('est42000_vrUniIgualZero');
    }


    public static function confVrAutomatico($param){
        throw new self('est42000_vrAuto', $param);
    }


    public static function erroUltimoProdLanc(){
        throw new self('est42000_ultimoProdLanc');
    }


    public static function erroProdAjustUltimo(){
        throw new self('est42000_prodAjustUltimo');
    }


    public static function erroProdAjustPrimeiro(){
        throw new self('est42000_prodAjustPrimeiro');
    }


    public static function erroProdNaoCad(){
        throw new self('est42000_prodNaoCadast');
    }


    public static function erroProdInvalido(){
        throw new self('est42000_prodInativo');
    }


    public static function erroProdNaoCtrlEstoq(){
        throw new self('est42000_prodNaoCtrlEstq');
    }


    public static function erroFilialSemCtrlEst(){
        throw new self('est42000_filialSemCtrlEst');
    }


    public static function erroQtdMultiplo($param){
        throw new self('est42000_qtdMultiplo', $param);
    }


    public static function erroSemSaldoProduto(){
        throw new self('est42000_prodSemSaldo');
    }


    public static function erroProdutoInativo(){
        throw new self('est41000_prodInativo');
    }


    public static function erroOrdemDiferente(){
        throw new self('est41000_erroOrdemDiferente');
    }


    public static function erroProdImplPrimeiro(){
        throw new self('est41000_ProdImplPrimeiro');
    }


    public static function erroProdImplUltimo(){
        throw new self('est41000_ProdImplUltimo');
    }


    public static function erroJaExistemItensLancados(){
        throw new self('est41000_jaExisteItensLanc');
    }


}
