<?php
namespace Planejamento\Logic\Cardapio;

use Geral\Util\DateUtil;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Planejamento\Entities\Prato;
use \Planejamento\Util\Parametros;
use \Planejamento\Logic\Cardapio\Safra;
use \Planejamento\Entities\Tipoprat;
use \Planejamento\Entities\Consserv;

/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 21/01/13
 * Time: 14:27
 */
class Custo
{

    const CALCULO_CUSTO = 'PLA_ANALISE_CUSTO_CARDAPIO';

    public static function calculoCusto(
        $nrconsplan, $nrorg, $cdfilial, $cdservfili, $dtinicial, $idarquivo, $idprodutos, $idsepprato,
        $peacrescimo, $idarredond, $cdprodutoini, $cdprodutofin, $cdoperador, $cdfilicalccusto, $nrtipocustopla,
        $nrtipocustoreal, $dtrefecusto
    ) {
        $dtfinal = self::getDataFinalMes($dtinicial);
//        $dia = DateUtil::getDia(DateUtil::getDataAtual());
//        $dtinicial = $dia.'/'.$dtinicial;
        $dtinicial = '01/'.$dtinicial;

        $procedure = new Procedure(self::CALCULO_CUSTO);
        $procedure->addParam(
            new Param (
                'P_CDFILIAL',
                Param::PARAM_INPUT,
                $cdfilial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDSERVFILI',
                Param::PARAM_INPUT,
                $cdservfili,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_DTINICIAL',
                Param::PARAM_INPUT,
                $dtinicial,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_DTFINAL',
                Param::PARAM_INPUT,
                $dtfinal,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDARQUIVO',
                Param::PARAM_INPUT,
                $idarquivo,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDPRODUTOS',
                Param::PARAM_INPUT,
                $idprodutos,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDSEPPRATO',
                Param::PARAM_INPUT,
                $idsepprato,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_PEACRESCIMO',
                Param::PARAM_INPUT,
                $peacrescimo,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_IDARREDOND',
                Param::PARAM_INPUT,
                $idarredond,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_NRCONSPLAN',
                Param::PARAM_INPUT,
                $nrconsplan,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDPRODUTOINI',
                Param::PARAM_INPUT,
                $cdprodutoini,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDPRODUTOFIN',
                Param::PARAM_INPUT,
                $cdprodutofin,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDOPERADOR',
                Param::PARAM_INPUT,
                $cdoperador,
                Param::PARAM_TYPE_STR
            )
        );
        $procedure->addParam(
            new Param (
                'P_CDFILICALCCUSTO',
                Param::PARAM_INPUT,
                $cdfilicalccusto,
                Param::PARAM_TYPE_STR,
                0
            )
        );
        $procedure->addParam(
            new Param (
                'P_NRTIPOCUSTOPLA',
                Param::PARAM_INPUT,
                $nrtipocustopla,
                Param::PARAM_TYPE_STR,
                0
            )
        );
        $procedure->addParam(
            new Param (
                'P_NRTIPOCUSTOREAL',
                Param::PARAM_INPUT,
                $nrtipocustoreal,
                Param::PARAM_TYPE_STR,
                0
            )
        );
        $procedure->addParam(
            new Param (
                'P_DTREFECUSTO',
                Param::PARAM_INPUT,
                $dtrefecusto,
                Param::PARAM_TYPE_STR,
                0
            )
        );
//        $procedure->addParam(
//            new Param (
//                'P_DTREFECUSTO',
//                Param::PARAM_INPUT,
//                $dtrefecusto->get('dd/MM/y'),
//                Param::PARAM_TYPE_STR,
//                0
//            )
//        );
        $procedure->addParam(
            new Param (
                'P_NRORG',
                Param::PARAM_INPUT,
                $nrorg,
                Param::PARAM_TYPE_INT,
                0
            )
        );

        $result = $procedure->call();
        return $result;

    }

    public function getDataFinalMes($dataInicial) {
        $data = new \TkDateTime($dataInicial, 'MM/y', 'pt_BR');
        $qtdeDiasDoMes = cal_days_in_month(CAL_GREGORIAN, $data->get('MM'), $data->get('y'));
        $data->setDay($qtdeDiasDoMes);
        $dataFinal = $data->get('dd/MM/y');
        return $dataFinal;
    }


    public static function analiseCustoPrato(
        $nrorg, $cdfilicusto, $cdfilial, $cdservfili, $dtcusto, $nrtipocusto,
        $dataProc, $dtrefecusto, $dtrefecustoant
    ){
        /** @var \Planejamento\Repositories\Prato $pratoRepository */
        $pratoRepository = Prato::getRepository();
        $custoPratos = $pratoRepository->retornaAnaliseCustoPrato(
            $nrorg, $cdfilicusto, $cdfilial, $cdservfili, $dtcusto, $nrtipocusto
        );

        if (empty($custoPratos) === false) {
            //Parametrização de cores
            $corEntreSafra = Parametros::getInstancia($cdfilial)->getNrCorEntrsaf();
            $corInicSaf = Parametros::getInstancia($cdfilial)->getNrCorInicSaf();
            $corSafra = Parametros::getInstancia($cdfilial)->getNrCorSafra();

            $mesAtual = DateUtil::getMes(DateUtil::getDataDeString($dataProc));

            $receitasDia = $pratoRepository->retornaAnaliseCustoReceita(
                $nrorg, $cdfilicusto, $cdfilial, $cdservfili, $dtrefecusto, $dtcusto,
                $dtrefecustoant, $nrtipocusto, $corEntreSafra, $corInicSaf, $corSafra,
                $mesAtual
            );

            $custoPrato = 0;
            $custoGeral = 0;
            foreach ($custoPratos as $chavePrato => $pratos){
                $cdprato = $pratos['CDPRATO'];
                $custoPerCapitaPrato = $pratos['CUSTOPERCAPITA'];

                foreach ($receitasDia as $chaveReceita => $receita) {
                    if ($receita['CDPRATO'] === $cdprato) {
                        if ($custoPerCapitaPrato > 0) {
                            $idSafra = $receita['IDINTESAFR'];
                            if ($idSafra == 2) {
                                $custoPrato +=  (($receita['QTDERECE']
                                            * $receita['CUSTOPROD']
                                            / $custoPerCapitaPrato) * 100
                                        / 2);
                            }

                            if ($idSafra == 3) {
                                $custoPrato += (($receita['QTDERECE']
                                            * $receita['CUSTOPROD']
                                            / $custoPerCapitaPrato) * 100);
                            }

                            unset($receitasDia[$chaveReceita]);
                        } else {
                            unset($receitasDia[$chaveReceita]);
                        }
                    } else {
                        break;
                    }
                }

                $corSafraTotal = Safra::retornaCorSafraGeral($nrorg, $custoPrato);
                $custoPratos[$chavePrato]['PERCENTUALSAFRA'] = $custoPrato;
                $custoPratos[$chavePrato]['NRCORSAFRA'] = $corSafraTotal;

                $custoGeral += $custoPrato;
                $custoPrato = 0;
            }
        }

        tk_set_context_vars('SAFRAGERAL', 'pla00106', $custoGeral);

        $corSafraGeral = Safra::retornaCorSafraGeral($nrorg, $custoGeral);
        tk_set_context_vars('CORSAFRAGERAL', 'pla00106', $corSafraGeral);

        return $custoPratos;
    }


    public static function analiseCustoConsumoServico(
        $cdservico, $data, $cdfilial, $comensaisEstimados,
        $cdfilicusto, $nrtipocusto, $nrorg, $tipoConsumo, $dtcusto
    ){
        /** @var \Planejamento\Repositories\Tipoprat $tipoPratRepository */
        $tipoPratRepository = Tipoprat::getRepository();
        $consumos = $tipoPratRepository->retornaCustoPadrao(
            $cdservico, $data, $cdfilial
        );

        $consumoProduto = array();
        if (empty($consumos[0]) === false) {
            /** @var \Planejamento\Repositories\Consserv $consservRepository */
            $consservRepository = Consserv::getRepository();
            $consumoProduto = $consservRepository->retornaConsumoProduto(
                $cdservico, $cdfilial, $comensaisEstimados, $dtcusto, $cdfilicusto,
                $nrtipocusto, $tipoConsumo
            );

            $custoFixo = '0.00000';
            $perCapitaFixo = '0.00000';

            $custoPer = '0.00000';
            $perCapitaPer = '0.00000';

            if (empty($consumoProduto[0]) === false) {
                foreach ($consumoProduto as $consumo) {
                    if ($consumo['TIPOCONS'] == 'F') {
                        $custoFixo += $consumo['CUSTOTOTAL'];
                        $perCapitaFixo += $consumo['CUSTOPERCAPITA'];
                    } else {
                        $custoPer += $consumo['CUSTOTOTAL'];
                        $perCapitaPer += $consumo['CUSTOPERCAPITA'];
                    }
                }
            } else {
                $consumoProduto = array(array('CDPRODUTO' => ''));
            }

            foreach($consumos as $chave => $cons) {
                if ($cons['TPCONS'] == 'F') {
                    $consumos[$chave]['CUSTOPERCAPITA'] = $perCapitaFixo;
                    $consumos[$chave]['CUSTOTOTAL'] = $custoFixo;
                } else {
                    $consumos[$chave]['CUSTOPERCAPITA'] = $perCapitaPer;
                    $consumos[$chave]['CUSTOTOTAL'] = $custoPer;
                }

            }

        } else {
            $consumos = array(array('VRCUSTPADRTP' => ''));
        }

        tk_set_context_vars('QUERY_PLA00106_010_PRODUTO', 'pla00106', $consumoProduto);
        return $consumos;

    }
}
