create or replace 
PROCEDURE IMPORTA_ALT_LISTA_PRECIOS
IS
   V_CDFILIAL  VARCHAR2(4);
   V_NUMCOLETA VARCHAR2(10);
   V_CDMARCA   VARCHAR2(5);
   V_CDREGIAO  VARCHAR2(3);
   V_CDFORNEC  VARCHAR2(21);
   V_CDPRODUTO VARCHAR2(10);
BEGIN
   FOR C_LISTAPRECO IN
       (SELECT U.CDCHAVE, U.VRPRECUNIITM, U.IDINTERFACE
          FROM USR_SAP_ALT_LISTPRECO U
         WHERE U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP
      V_CDFILIAL  := SUBSTR(C_LISTAPRECO.CDCHAVE, 1, 4);
      V_NUMCOLETA := SUBSTR(C_LISTAPRECO.CDCHAVE, 5, 10);
      V_CDMARCA   := SUBSTR(C_LISTAPRECO.CDCHAVE, 15, 5);
      V_CDREGIAO  := SUBSTR(C_LISTAPRECO.CDCHAVE, 20, 3);
      
      IF LENGTH(C_LISTAPRECO.CDCHAVE) = 53 THEN
         V_CDFORNEC := SUBSTR(C_LISTAPRECO.CDCHAVE, 23, 21);
      ELSE
         V_CDFORNEC := SUBSTR(C_LISTAPRECO.CDCHAVE, 23, ((LENGTH(C_LISTAPRECO.CDCHAVE)-10)-22));
      END IF;
      
      V_CDPRODUTO := SUBSTR(C_LISTAPRECO.CDCHAVE, -10);
      
      UPDATE ITEMCOLE
         SET VRPRECOITMPI = C_LISTAPRECO.VRPRECUNIITM
       WHERE CDFILIAL     = V_CDFILIAL
         AND NRCOLEPRECO  = V_NUMCOLETA
         AND CDMARCA      = V_CDMARCA
         AND CDREGIAO     = V_CDREGIAO
         AND CDFORNECED   = V_CDFORNEC
         AND CDPRODUTO    = V_CDPRODUTO;
      
      IF SQL%ROWCOUNT > 0 THEN
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_LISTAPRECO.IDINTERFACE, 'A', 1, SYSDATE, 0, 'Lista de preo atualizada com sucesso.');

         UPDATE USR_SAP_ALT_LISTPRECO SET DTINTERFACEDEST = SYSDATE, STATUS = 0
          WHERE IDINTERFACE = C_LISTAPRECO.IDINTERFACE;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES (C_LISTAPRECO.IDINTERFACE, 'A', 1, SYSDATE, 1, 'NAO ATUALIZOU NENHUM REGISTRO');

         UPDATE USR_SAP_ALT_LISTPRECO SET STATUS = 2
          WHERE IDINTERFACE = C_LISTAPRECO.IDINTERFACE;
      END IF;
   END LOOP;
   
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_ALT_LISTA_PRECIOS','5.45.XXX'); END;
/